"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @jest-environment jsdom
 */
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var enzyme_1 = require("enzyme");
var src_1 = __importDefault(require("../src"));
test('renders form with TextInputs', function () {
    var mounted = enzyme_1.mount(<src_1.default>
      <react_native_1.TextInput placeholder="Test" testID="first"/>
      <react_native_1.TextInput placeholder="Test 1" testID="second"/>
    </src_1.default>);
    var first = mounted
        .find('TextInput')
        .findWhere(function (x) { return x.prop('testID') === 'first'; })
        .first()
        .props();
    var second = mounted
        .find('TextInput')
        .findWhere(function (x) { return x.prop('testID') === 'second'; })
        .first()
        .props();
    expect(first.returnKeyType).toBe('next');
    expect(first.blurOnSubmit).toBe(false);
    expect(second.returnKeyType).toBe('done');
    expect(second.blurOnSubmit).toBe(true);
});
test('renders form with custom components', function () {
    var CustomInput = react_1.default.forwardRef(function (_a, ref) {
        var props = __rest(_a, []);
        return <react_native_1.TextInput ref={ref} {...props}/>;
    });
    var mounted = enzyme_1.mount(<src_1.default inputComponentTypes={[CustomInput]}>
      <CustomInput placeholder="Test" testID="first"/>
      <CustomInput placeholder="Test 1" testID="second"/>
      <CustomInput placeholder="Test 2" testID="third"/>
    </src_1.default>);
    var first = mounted
        .find('TextInput')
        .findWhere(function (x) { return x.prop('testID') === 'first'; })
        .first()
        .props();
    var second = mounted
        .find('TextInput')
        .findWhere(function (x) { return x.prop('testID') === 'second'; })
        .first()
        .props();
    var third = mounted
        .find('TextInput')
        .findWhere(function (x) { return x.prop('testID') === 'third'; })
        .first()
        .props();
    expect(first.returnKeyType).toBe('next');
    expect(first.blurOnSubmit).toBe(false);
    expect(second.returnKeyType).toBe('next');
    expect(second.blurOnSubmit).toBe(false);
    expect(third.returnKeyType).toBe('done');
    expect(third.blurOnSubmit).toBe(true);
});
