"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var NextableForm = function (_a) {
    var children = _a.children, _b = _a.onDone, onDone = _b === void 0 ? function () { } : _b, _c = _a.inputComponentTypes, inputComponentTypes = _c === void 0 ? [react_native_1.TextInput] : _c;
    var allInputs = [];
    var allRefs = {};
    /**
     * This will find all nested elements in children
     * and execute custom function on them
     */
    function iterateOverAllComponents(children, fn) {
        return React.Children.map(children, function (child) {
            if (!React.isValidElement(child)) {
                return child;
            }
            var validElement = child;
            if (validElement.props.children) {
                child = React.cloneElement(validElement, {
                    children: iterateOverAllComponents(validElement.props.children, fn),
                });
            }
            return fn(child);
        });
    }
    /**
     * This will first count all the inputs
     * so that we can decide which one is the last and make return type "done"
     */
    iterateOverAllComponents(children, function (item) {
        if (inputComponentTypes.indexOf(item.type) > -1) {
            allInputs.push(item);
        }
        return null;
    });
    /**
     * Clone each element that maches and add custom properties to it
     * to handle actions from keyboard
     */
    var nextChildren = iterateOverAllComponents(children, function (item) {
        if (inputComponentTypes.indexOf(item.type) > -1) {
            var currentInputIndex_1 = allInputs.indexOf(item);
            var isLast_1 = currentInputIndex_1 === allInputs.length - 1;
            return React.cloneElement(item, {
                ref: function (ref) {
                    allRefs[currentInputIndex_1] = ref;
                },
                /* The last one is 'done' */
                returnKeyType: isLast_1 ? 'done' : 'next',
                /** This prevents rescrolling after pressing 'next' */
                blurOnSubmit: isLast_1 ? true : false,
                onSubmitEditing: function () {
                    if (isLast_1) {
                        onDone();
                    }
                    else {
                        var nextInputRef = allRefs[currentInputIndex_1 + 1];
                        if (nextInputRef)
                            nextInputRef.focus();
                    }
                },
            });
        }
        return item;
    });
    return <React.Fragment>{nextChildren}</React.Fragment>;
};
exports.default = React.memo(NextableForm);
